#ifndef DLLSAMPLE_H
#define DLLSAMPLE_H

#define EXPFUNC __declspec(dllexport)

#include <windows.h>
//
#pragma pack(push,1)
struct RateInfo
{
    __int64           ctm;
    double            open;
    double            low;
    double            high;
    double            close;
    unsigned __int64  vol_tick;
    int               spread;
    unsigned __int64  vol_real;
};
#pragma pack(pop)
//---
struct MqlStr
{
    int               len;
    char             *string;
};
//
static int CompareMqlStr(const void *left,const void *right);
//
BOOL APIENTRY DllMain(HANDLE ,DWORD ul_reason_for_call,LPVOID);
extern "C"{
EXPFUNC int __stdcall GetIntValue(const int ipar);
EXPFUNC double __stdcall GetDoubleValue(const double dpar);
EXPFUNC wchar_t* __stdcall GetStringValue(wchar_t *spar);
EXPFUNC double __stdcall GetArrayItemValue(const double *arr,const int arraysize,const int nitem);
EXPFUNC bool _stdcall SetArrayItemValue(double *arr,const int arraysize,const int nitem,const double value);
EXPFUNC double __stdcall GetRatesItemValue(const RateInfo* rates,const int rates_total,const int shift,const int nrate);
EXPFUNC int __stdcall SortStringArray(MqlStr *arr,const int arraysize);
EXPFUNC int __stdcall ProcessStringArray(MqlStr *arr,const int arraysize);
}
#endif // DLLSAMPLE_H
